"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emitEnd = exports.emitMethods = exports.emitProperties = exports.emitFields = exports.emitAttributes = void 0;
const ScopeTokens = require("../tokens/scope_tokens");
const AttributeEmitter = require("./attribute_emitter");
const FieldEmitter = require("./field_emitter");
const PropertyEmitter = require("./property_emitter");
const MethodEmitter = require("./method_emitter");
function emitAttributes(writer, attributes) {
    AttributeEmitter.emitMany(writer, attributes);
}
exports.emitAttributes = emitAttributes;
function emitFields(writer, fields) {
    FieldEmitter.emitMany(writer, fields, true);
}
exports.emitFields = emitFields;
function emitProperties(writer, properties, fields) {
    PropertyEmitter.emitMany(writer, properties, (fields == null || fields.length === 0));
}
exports.emitProperties = emitProperties;
function emitMethods(writer, methods, properties) {
    MethodEmitter.emitMany(writer, methods, (properties == null || properties.length === 0));
}
exports.emitMethods = emitMethods;
function emitEnd(writer, isLast) {
    writer
        .unindent()
        .writeLine(ScopeTokens.close);
    if (!isLast)
        writer.writeLine();
}
exports.emitEnd = emitEnd;
